/* Interfaces2.c generated by valac 0.34.4, the Vala compiler
 * generated from Interfaces2.vala, do not modify */

/*
 * Copyright (C) 2010 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define TYPE_MEDIA_OBJECT2 (media_object2_get_type ())
#define MEDIA_OBJECT2(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_OBJECT2, MediaObject2))
#define IS_MEDIA_OBJECT2(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_OBJECT2))
#define MEDIA_OBJECT2_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MEDIA_OBJECT2, MediaObject2Iface))

typedef struct _MediaObject2 MediaObject2;
typedef struct _MediaObject2Iface MediaObject2Iface;

#define TYPE_MEDIA_OBJECT2_PROXY (media_object2_proxy_get_type ())
typedef GDBusProxy MediaObject2Proxy;
typedef GDBusProxyClass MediaObject2ProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_MEDIA_CONTAINER2 (media_container2_get_type ())
#define MEDIA_CONTAINER2(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_CONTAINER2, MediaContainer2))
#define IS_MEDIA_CONTAINER2(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_CONTAINER2))
#define MEDIA_CONTAINER2_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MEDIA_CONTAINER2, MediaContainer2Iface))

typedef struct _MediaContainer2 MediaContainer2;
typedef struct _MediaContainer2Iface MediaContainer2Iface;

#define TYPE_MEDIA_CONTAINER2_PROXY (media_container2_proxy_get_type ())
typedef GDBusProxy MediaContainer2Proxy;
typedef GDBusProxyClass MediaContainer2ProxyClass;

#define TYPE_MEDIA_ITEM2 (media_item2_get_type ())
#define MEDIA_ITEM2(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_ITEM2, MediaItem2))
#define IS_MEDIA_ITEM2(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_ITEM2))
#define MEDIA_ITEM2_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MEDIA_ITEM2, MediaItem2Iface))

typedef struct _MediaItem2 MediaItem2;
typedef struct _MediaItem2Iface MediaItem2Iface;

#define TYPE_MEDIA_ITEM2_PROXY (media_item2_proxy_get_type ())
typedef GDBusProxy MediaItem2Proxy;
typedef GDBusProxyClass MediaItem2ProxyClass;

struct _MediaObject2Iface {
	GTypeInterface parent_iface;
	char* (*get_Parent) (MediaObject2* self);
	gchar* (*get_DisplayName) (MediaObject2* self);
	gchar* (*get_Type) (MediaObject2* self);
	gchar* (*get_Path) (MediaObject2* self);
};

struct _MediaContainer2Iface {
	GTypeInterface parent_iface;
	GHashTable** (*ListChildren) (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error);
	GHashTable** (*ListContainers) (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error);
	GHashTable** (*ListItems) (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error);
	guint (*get_ChildCount) (MediaContainer2* self);
	guint (*get_ItemCount) (MediaContainer2* self);
	guint (*get_ContainerCount) (MediaContainer2* self);
	gboolean (*get_Searchable) (MediaContainer2* self);
};

struct _MediaItem2Iface {
	GTypeInterface parent_iface;
	gchar** (*get_URLs) (MediaItem2* self, int* result_length1);
	gchar* (*get_MIMEType) (MediaItem2* self);
};



GType media_object2_get_type (void) G_GNUC_CONST;
GType media_object2_proxy_get_type (void) G_GNUC_CONST;
guint media_object2_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
char* media_object2_get_Parent (MediaObject2* self);
gchar* media_object2_get_DisplayName (MediaObject2* self);
gchar* media_object2_get_Type (MediaObject2* self);
gchar* media_object2_get_Path (MediaObject2* self);
static void media_object2_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static char* media_object2_dbus_proxy_get_Parent (MediaObject2* self);
static gchar* media_object2_dbus_proxy_get_DisplayName (MediaObject2* self);
static gchar* media_object2_dbus_proxy_get_Type (MediaObject2* self);
static gchar* media_object2_dbus_proxy_get_Path (MediaObject2* self);
static void media_object2_proxy_media_object2_interface_init (MediaObject2Iface* iface);
static void media_object2_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* media_object2_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_media_object2_get_Parent (MediaObject2* self);
static GVariant* _dbus_media_object2_get_DisplayName (MediaObject2* self);
static GVariant* _dbus_media_object2_get_Type (MediaObject2* self);
static GVariant* _dbus_media_object2_get_Path (MediaObject2* self);
static gboolean media_object2_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _media_object2_unregister_object (gpointer user_data);
GType media_container2_proxy_get_type (void) G_GNUC_CONST;
guint media_container2_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType media_container2_get_type (void) G_GNUC_CONST;
GHashTable** media_container2_ListChildren (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error);
GHashTable** media_container2_ListContainers (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error);
GHashTable** media_container2_ListItems (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error);
guint media_container2_get_ChildCount (MediaContainer2* self);
guint media_container2_get_ItemCount (MediaContainer2* self);
guint media_container2_get_ContainerCount (MediaContainer2* self);
gboolean media_container2_get_Searchable (MediaContainer2* self);
static void media_container2_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_media_container2_updated (MediaContainer2* self, GVariant* parameters);
static GHashTable** media_container2_proxy_ListChildren (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error);
static GHashTable** media_container2_proxy_ListContainers (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error);
static GHashTable** media_container2_proxy_ListItems (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error);
static guint media_container2_dbus_proxy_get_ChildCount (MediaContainer2* self);
static guint media_container2_dbus_proxy_get_ItemCount (MediaContainer2* self);
static guint media_container2_dbus_proxy_get_ContainerCount (MediaContainer2* self);
static gboolean media_container2_dbus_proxy_get_Searchable (MediaContainer2* self);
static void media_container2_proxy_media_container2_interface_init (MediaContainer2Iface* iface);
static void _dbus_media_container2_ListChildren (MediaContainer2* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_media_container2_ListContainers (MediaContainer2* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_media_container2_ListItems (MediaContainer2* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void media_container2_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* media_container2_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_media_container2_get_ChildCount (MediaContainer2* self);
static GVariant* _dbus_media_container2_get_ItemCount (MediaContainer2* self);
static GVariant* _dbus_media_container2_get_ContainerCount (MediaContainer2* self);
static GVariant* _dbus_media_container2_get_Searchable (MediaContainer2* self);
static gboolean media_container2_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_media_container2_updated (GObject* _sender, gpointer* _data);
static void _media_container2_unregister_object (gpointer user_data);
GType media_item2_get_type (void) G_GNUC_CONST;
GType media_item2_proxy_get_type (void) G_GNUC_CONST;
guint media_item2_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
gchar** media_item2_get_URLs (MediaItem2* self, int* result_length1);
gchar* media_item2_get_MIMEType (MediaItem2* self);
static void media_item2_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static gchar** media_item2_dbus_proxy_get_URLs (MediaItem2* self, int* result_length1);
static gchar* media_item2_dbus_proxy_get_MIMEType (MediaItem2* self);
static void media_item2_proxy_media_item2_interface_init (MediaItem2Iface* iface);
static void media_item2_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* media_item2_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_media_item2_get_URLs (MediaItem2* self);
static GVariant* _dbus_media_item2_get_MIMEType (MediaItem2* self);
static gboolean media_item2_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _media_item2_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusMethodInfo * const _media_object2_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _media_object2_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _media_object2_dbus_property_info_Parent = {-1, "Parent", "o", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _media_object2_dbus_property_info_DisplayName = {-1, "DisplayName", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _media_object2_dbus_property_info_Type = {-1, "Type", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _media_object2_dbus_property_info_Path = {-1, "Path", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo * const _media_object2_dbus_property_info[] = {&_media_object2_dbus_property_info_Parent, &_media_object2_dbus_property_info_DisplayName, &_media_object2_dbus_property_info_Type, &_media_object2_dbus_property_info_Path, NULL};
static const GDBusInterfaceInfo _media_object2_dbus_interface_info = {-1, "org.gnome.UPnP.MediaObject2", (GDBusMethodInfo **) (&_media_object2_dbus_method_info), (GDBusSignalInfo **) (&_media_object2_dbus_signal_info), (GDBusPropertyInfo **) (&_media_object2_dbus_property_info)};
static const GDBusInterfaceVTable _media_object2_dbus_interface_vtable = {media_object2_dbus_interface_method_call, media_object2_dbus_interface_get_property, media_object2_dbus_interface_set_property};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListChildren_offset = {-1, "offset", "u"};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListChildren_max = {-1, "max", "u"};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListChildren_filter = {-1, "filter", "as"};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListChildren_result = {-1, "result", "aa{sv}"};
static const GDBusArgInfo * const _media_container2_dbus_arg_info_ListChildren_in[] = {&_media_container2_dbus_arg_info_ListChildren_offset, &_media_container2_dbus_arg_info_ListChildren_max, &_media_container2_dbus_arg_info_ListChildren_filter, NULL};
static const GDBusArgInfo * const _media_container2_dbus_arg_info_ListChildren_out[] = {&_media_container2_dbus_arg_info_ListChildren_result, NULL};
static const GDBusMethodInfo _media_container2_dbus_method_info_ListChildren = {-1, "ListChildren", (GDBusArgInfo **) (&_media_container2_dbus_arg_info_ListChildren_in), (GDBusArgInfo **) (&_media_container2_dbus_arg_info_ListChildren_out)};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListContainers_offset = {-1, "offset", "u"};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListContainers_max = {-1, "max", "u"};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListContainers_filter = {-1, "filter", "as"};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListContainers_result = {-1, "result", "aa{sv}"};
static const GDBusArgInfo * const _media_container2_dbus_arg_info_ListContainers_in[] = {&_media_container2_dbus_arg_info_ListContainers_offset, &_media_container2_dbus_arg_info_ListContainers_max, &_media_container2_dbus_arg_info_ListContainers_filter, NULL};
static const GDBusArgInfo * const _media_container2_dbus_arg_info_ListContainers_out[] = {&_media_container2_dbus_arg_info_ListContainers_result, NULL};
static const GDBusMethodInfo _media_container2_dbus_method_info_ListContainers = {-1, "ListContainers", (GDBusArgInfo **) (&_media_container2_dbus_arg_info_ListContainers_in), (GDBusArgInfo **) (&_media_container2_dbus_arg_info_ListContainers_out)};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListItems_offset = {-1, "offset", "u"};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListItems_max = {-1, "max", "u"};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListItems_filter = {-1, "filter", "as"};
static const GDBusArgInfo _media_container2_dbus_arg_info_ListItems_result = {-1, "result", "aa{sv}"};
static const GDBusArgInfo * const _media_container2_dbus_arg_info_ListItems_in[] = {&_media_container2_dbus_arg_info_ListItems_offset, &_media_container2_dbus_arg_info_ListItems_max, &_media_container2_dbus_arg_info_ListItems_filter, NULL};
static const GDBusArgInfo * const _media_container2_dbus_arg_info_ListItems_out[] = {&_media_container2_dbus_arg_info_ListItems_result, NULL};
static const GDBusMethodInfo _media_container2_dbus_method_info_ListItems = {-1, "ListItems", (GDBusArgInfo **) (&_media_container2_dbus_arg_info_ListItems_in), (GDBusArgInfo **) (&_media_container2_dbus_arg_info_ListItems_out)};
static const GDBusMethodInfo * const _media_container2_dbus_method_info[] = {&_media_container2_dbus_method_info_ListChildren, &_media_container2_dbus_method_info_ListContainers, &_media_container2_dbus_method_info_ListItems, NULL};
static const GDBusArgInfo * const _media_container2_dbus_arg_info_updated[] = {NULL};
static const GDBusSignalInfo _media_container2_dbus_signal_info_updated = {-1, "Updated", (GDBusArgInfo **) (&_media_container2_dbus_arg_info_updated)};
static const GDBusSignalInfo * const _media_container2_dbus_signal_info[] = {&_media_container2_dbus_signal_info_updated, NULL};
static const GDBusPropertyInfo _media_container2_dbus_property_info_ChildCount = {-1, "ChildCount", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _media_container2_dbus_property_info_ItemCount = {-1, "ItemCount", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _media_container2_dbus_property_info_ContainerCount = {-1, "ContainerCount", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _media_container2_dbus_property_info_Searchable = {-1, "Searchable", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo * const _media_container2_dbus_property_info[] = {&_media_container2_dbus_property_info_ChildCount, &_media_container2_dbus_property_info_ItemCount, &_media_container2_dbus_property_info_ContainerCount, &_media_container2_dbus_property_info_Searchable, NULL};
static const GDBusInterfaceInfo _media_container2_dbus_interface_info = {-1, "org.gnome.UPnP.MediaContainer2", (GDBusMethodInfo **) (&_media_container2_dbus_method_info), (GDBusSignalInfo **) (&_media_container2_dbus_signal_info), (GDBusPropertyInfo **) (&_media_container2_dbus_property_info)};
static const GDBusInterfaceVTable _media_container2_dbus_interface_vtable = {media_container2_dbus_interface_method_call, media_container2_dbus_interface_get_property, media_container2_dbus_interface_set_property};
static const GDBusMethodInfo * const _media_item2_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _media_item2_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _media_item2_dbus_property_info_URLs = {-1, "URLs", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo _media_item2_dbus_property_info_MIMEType = {-1, "MIMEType", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE};
static const GDBusPropertyInfo * const _media_item2_dbus_property_info[] = {&_media_item2_dbus_property_info_URLs, &_media_item2_dbus_property_info_MIMEType, NULL};
static const GDBusInterfaceInfo _media_item2_dbus_interface_info = {-1, "org.gnome.UPnP.MediaItem2", (GDBusMethodInfo **) (&_media_item2_dbus_method_info), (GDBusSignalInfo **) (&_media_item2_dbus_signal_info), (GDBusPropertyInfo **) (&_media_item2_dbus_property_info)};
static const GDBusInterfaceVTable _media_item2_dbus_interface_vtable = {media_item2_dbus_interface_method_call, media_item2_dbus_interface_get_property, media_item2_dbus_interface_set_property};

char* media_object2_get_Parent (MediaObject2* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return MEDIA_OBJECT2_GET_INTERFACE (self)->get_Parent (self);
}


gchar* media_object2_get_DisplayName (MediaObject2* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return MEDIA_OBJECT2_GET_INTERFACE (self)->get_DisplayName (self);
}


gchar* media_object2_get_Type (MediaObject2* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return MEDIA_OBJECT2_GET_INTERFACE (self)->get_Type (self);
}


gchar* media_object2_get_Path (MediaObject2* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return MEDIA_OBJECT2_GET_INTERFACE (self)->get_Path (self);
}


static void media_object2_base_init (MediaObject2Iface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType media_object2_get_type (void) {
	static volatile gsize media_object2_type_id__volatile = 0;
	if (g_once_init_enter (&media_object2_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MediaObject2Iface), (GBaseInitFunc) media_object2_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType media_object2_type_id;
		media_object2_type_id = g_type_register_static (G_TYPE_INTERFACE, "MediaObject2", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (media_object2_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (media_object2_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) media_object2_proxy_get_type);
		g_type_set_qdata (media_object2_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.UPnP.MediaObject2");
		g_type_set_qdata (media_object2_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_media_object2_dbus_interface_info));
		g_type_set_qdata (media_object2_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) media_object2_register_object);
		g_once_init_leave (&media_object2_type_id__volatile, media_object2_type_id);
	}
	return media_object2_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (MediaObject2Proxy, media_object2_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_MEDIA_OBJECT2, media_object2_proxy_media_object2_interface_init) )
static void media_object2_proxy_class_init (MediaObject2ProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = media_object2_proxy_g_signal;
}


static void media_object2_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
}


static void media_object2_proxy_init (MediaObject2Proxy* self) {
}


static char* media_object2_dbus_proxy_get_Parent (MediaObject2* self) {
	GVariant *_inner_reply;
	char* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Parent");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.UPnP.MediaObject2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Parent"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static gchar* media_object2_dbus_proxy_get_DisplayName (MediaObject2* self) {
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "DisplayName");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.UPnP.MediaObject2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("DisplayName"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static gchar* media_object2_dbus_proxy_get_Type (MediaObject2* self) {
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Type");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.UPnP.MediaObject2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Type"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static gchar* media_object2_dbus_proxy_get_Path (MediaObject2* self) {
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Path");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.UPnP.MediaObject2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Path"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static void media_object2_proxy_media_object2_interface_init (MediaObject2Iface* iface) {
	iface->get_Parent = media_object2_dbus_proxy_get_Parent;
	iface->get_DisplayName = media_object2_dbus_proxy_get_DisplayName;
	iface->get_Type = media_object2_dbus_proxy_get_Type;
	iface->get_Path = media_object2_dbus_proxy_get_Path;
}


static void media_object2_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}


static GVariant* _dbus_media_object2_get_Parent (MediaObject2* self) {
	char* result;
	GVariant* _reply;
	result = media_object2_get_Parent (self);
	_reply = g_variant_new_object_path (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_media_object2_get_DisplayName (MediaObject2* self) {
	gchar* result;
	GVariant* _reply;
	result = media_object2_get_DisplayName (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_media_object2_get_Type (MediaObject2* self) {
	gchar* result;
	GVariant* _reply;
	result = media_object2_get_Type (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_media_object2_get_Path (MediaObject2* self) {
	gchar* result;
	GVariant* _reply;
	result = media_object2_get_Path (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* media_object2_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Parent") == 0) {
		return _dbus_media_object2_get_Parent (object);
	} else if (strcmp (property_name, "DisplayName") == 0) {
		return _dbus_media_object2_get_DisplayName (object);
	} else if (strcmp (property_name, "Type") == 0) {
		return _dbus_media_object2_get_Type (object);
	} else if (strcmp (property_name, "Path") == 0) {
		return _dbus_media_object2_get_Path (object);
	}
	return NULL;
}


static gboolean media_object2_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint media_object2_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_media_object2_dbus_interface_info), &_media_object2_dbus_interface_vtable, data, _media_object2_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _media_object2_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


GHashTable** media_container2_ListChildren (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return MEDIA_CONTAINER2_GET_INTERFACE (self)->ListChildren (self, offset, max, filter, filter_length1, result_length1, error);
}


GHashTable** media_container2_ListContainers (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return MEDIA_CONTAINER2_GET_INTERFACE (self)->ListContainers (self, offset, max, filter, filter_length1, result_length1, error);
}


GHashTable** media_container2_ListItems (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return MEDIA_CONTAINER2_GET_INTERFACE (self)->ListItems (self, offset, max, filter, filter_length1, result_length1, error);
}


guint media_container2_get_ChildCount (MediaContainer2* self) {
	g_return_val_if_fail (self != NULL, 0U);
	return MEDIA_CONTAINER2_GET_INTERFACE (self)->get_ChildCount (self);
}


guint media_container2_get_ItemCount (MediaContainer2* self) {
	g_return_val_if_fail (self != NULL, 0U);
	return MEDIA_CONTAINER2_GET_INTERFACE (self)->get_ItemCount (self);
}


guint media_container2_get_ContainerCount (MediaContainer2* self) {
	g_return_val_if_fail (self != NULL, 0U);
	return MEDIA_CONTAINER2_GET_INTERFACE (self)->get_ContainerCount (self);
}


gboolean media_container2_get_Searchable (MediaContainer2* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return MEDIA_CONTAINER2_GET_INTERFACE (self)->get_Searchable (self);
}


static void media_container2_base_init (MediaContainer2Iface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("updated", TYPE_MEDIA_CONTAINER2, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	}
}


GType media_container2_get_type (void) {
	static volatile gsize media_container2_type_id__volatile = 0;
	if (g_once_init_enter (&media_container2_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MediaContainer2Iface), (GBaseInitFunc) media_container2_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType media_container2_type_id;
		media_container2_type_id = g_type_register_static (G_TYPE_INTERFACE, "MediaContainer2", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (media_container2_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (media_container2_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) media_container2_proxy_get_type);
		g_type_set_qdata (media_container2_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.UPnP.MediaContainer2");
		g_type_set_qdata (media_container2_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_media_container2_dbus_interface_info));
		g_type_set_qdata (media_container2_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) media_container2_register_object);
		g_once_init_leave (&media_container2_type_id__volatile, media_container2_type_id);
	}
	return media_container2_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (MediaContainer2Proxy, media_container2_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_MEDIA_CONTAINER2, media_container2_proxy_media_container2_interface_init) )
static void media_container2_proxy_class_init (MediaContainer2ProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = media_container2_proxy_g_signal;
}


static void _dbus_handle_media_container2_updated (MediaContainer2* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "updated");
}


static void media_container2_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "Updated") == 0) {
		_dbus_handle_media_container2_updated ((MediaContainer2*) proxy, parameters);
	}
}


static void media_container2_proxy_init (MediaContainer2Proxy* self) {
}


static GHashTable** media_container2_proxy_ListChildren (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp418_;
	GVariantBuilder _tmp419_;
	int _tmp420_;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable** _result;
	int _result_length1;
	GVariant* _tmp421_;
	GHashTable** _tmp422_;
	int _tmp422__length;
	int _tmp422__size;
	int _tmp422__length1;
	GVariantIter _tmp423_;
	GVariant* _tmp424_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.UPnP.MediaContainer2", "ListChildren");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (offset));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (max));
	_tmp418_ = filter;
	g_variant_builder_init (&_tmp419_, G_VARIANT_TYPE ("as"));
	for (_tmp420_ = 0; _tmp420_ < filter_length1; _tmp420_++) {
		g_variant_builder_add_value (&_tmp419_, g_variant_new_string (*_tmp418_));
		_tmp418_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp419_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp421_ = g_variant_iter_next_value (&_reply_iter);
	_tmp422_ = g_new (GHashTable*, 5);
	_tmp422__length = 0;
	_tmp422__size = 4;
	_tmp422__length1 = 0;
	g_variant_iter_init (&_tmp423_, _tmp421_);
	for (; (_tmp424_ = g_variant_iter_next_value (&_tmp423_)) != NULL; _tmp422__length1++) {
		GHashTable* _tmp425_;
		GVariantIter _tmp426_;
		GVariant* _tmp427_;
		GVariant* _tmp428_;
		if (_tmp422__size == _tmp422__length) {
			_tmp422__size = 2 * _tmp422__size;
			_tmp422_ = g_renew (GHashTable*, _tmp422_, _tmp422__size + 1);
		}
		_tmp425_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp426_, _tmp424_);
		while (g_variant_iter_loop (&_tmp426_, "{?*}", &_tmp427_, &_tmp428_)) {
			g_hash_table_insert (_tmp425_, g_variant_dup_string (_tmp427_, NULL), g_variant_get_variant (_tmp428_));
		}
		_tmp422_[_tmp422__length++] = _tmp425_;
		g_variant_unref (_tmp424_);
	}
	_result_length1 = _tmp422__length1;
	_tmp422_[_tmp422__length] = NULL;
	_result = _tmp422_;
	g_variant_unref (_tmp421_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}


static GHashTable** media_container2_proxy_ListContainers (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp429_;
	GVariantBuilder _tmp430_;
	int _tmp431_;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable** _result;
	int _result_length1;
	GVariant* _tmp432_;
	GHashTable** _tmp433_;
	int _tmp433__length;
	int _tmp433__size;
	int _tmp433__length1;
	GVariantIter _tmp434_;
	GVariant* _tmp435_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.UPnP.MediaContainer2", "ListContainers");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (offset));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (max));
	_tmp429_ = filter;
	g_variant_builder_init (&_tmp430_, G_VARIANT_TYPE ("as"));
	for (_tmp431_ = 0; _tmp431_ < filter_length1; _tmp431_++) {
		g_variant_builder_add_value (&_tmp430_, g_variant_new_string (*_tmp429_));
		_tmp429_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp430_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp432_ = g_variant_iter_next_value (&_reply_iter);
	_tmp433_ = g_new (GHashTable*, 5);
	_tmp433__length = 0;
	_tmp433__size = 4;
	_tmp433__length1 = 0;
	g_variant_iter_init (&_tmp434_, _tmp432_);
	for (; (_tmp435_ = g_variant_iter_next_value (&_tmp434_)) != NULL; _tmp433__length1++) {
		GHashTable* _tmp436_;
		GVariantIter _tmp437_;
		GVariant* _tmp438_;
		GVariant* _tmp439_;
		if (_tmp433__size == _tmp433__length) {
			_tmp433__size = 2 * _tmp433__size;
			_tmp433_ = g_renew (GHashTable*, _tmp433_, _tmp433__size + 1);
		}
		_tmp436_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp437_, _tmp435_);
		while (g_variant_iter_loop (&_tmp437_, "{?*}", &_tmp438_, &_tmp439_)) {
			g_hash_table_insert (_tmp436_, g_variant_dup_string (_tmp438_, NULL), g_variant_get_variant (_tmp439_));
		}
		_tmp433_[_tmp433__length++] = _tmp436_;
		g_variant_unref (_tmp435_);
	}
	_result_length1 = _tmp433__length1;
	_tmp433_[_tmp433__length] = NULL;
	_result = _tmp433_;
	g_variant_unref (_tmp432_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}


static GHashTable** media_container2_proxy_ListItems (MediaContainer2* self, guint offset, guint max, gchar** filter, int filter_length1, int* result_length1, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp440_;
	GVariantBuilder _tmp441_;
	int _tmp442_;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable** _result;
	int _result_length1;
	GVariant* _tmp443_;
	GHashTable** _tmp444_;
	int _tmp444__length;
	int _tmp444__size;
	int _tmp444__length1;
	GVariantIter _tmp445_;
	GVariant* _tmp446_;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.UPnP.MediaContainer2", "ListItems");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (offset));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (max));
	_tmp440_ = filter;
	g_variant_builder_init (&_tmp441_, G_VARIANT_TYPE ("as"));
	for (_tmp442_ = 0; _tmp442_ < filter_length1; _tmp442_++) {
		g_variant_builder_add_value (&_tmp441_, g_variant_new_string (*_tmp440_));
		_tmp440_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp441_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp443_ = g_variant_iter_next_value (&_reply_iter);
	_tmp444_ = g_new (GHashTable*, 5);
	_tmp444__length = 0;
	_tmp444__size = 4;
	_tmp444__length1 = 0;
	g_variant_iter_init (&_tmp445_, _tmp443_);
	for (; (_tmp446_ = g_variant_iter_next_value (&_tmp445_)) != NULL; _tmp444__length1++) {
		GHashTable* _tmp447_;
		GVariantIter _tmp448_;
		GVariant* _tmp449_;
		GVariant* _tmp450_;
		if (_tmp444__size == _tmp444__length) {
			_tmp444__size = 2 * _tmp444__size;
			_tmp444_ = g_renew (GHashTable*, _tmp444_, _tmp444__size + 1);
		}
		_tmp447_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp448_, _tmp446_);
		while (g_variant_iter_loop (&_tmp448_, "{?*}", &_tmp449_, &_tmp450_)) {
			g_hash_table_insert (_tmp447_, g_variant_dup_string (_tmp449_, NULL), g_variant_get_variant (_tmp450_));
		}
		_tmp444_[_tmp444__length++] = _tmp447_;
		g_variant_unref (_tmp446_);
	}
	_result_length1 = _tmp444__length1;
	_tmp444_[_tmp444__length] = NULL;
	_result = _tmp444_;
	g_variant_unref (_tmp443_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}


static guint media_container2_dbus_proxy_get_ChildCount (MediaContainer2* self) {
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "ChildCount");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.UPnP.MediaContainer2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("ChildCount"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return 0U;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static guint media_container2_dbus_proxy_get_ItemCount (MediaContainer2* self) {
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "ItemCount");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.UPnP.MediaContainer2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("ItemCount"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return 0U;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static guint media_container2_dbus_proxy_get_ContainerCount (MediaContainer2* self) {
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "ContainerCount");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.UPnP.MediaContainer2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("ContainerCount"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return 0U;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static gboolean media_container2_dbus_proxy_get_Searchable (MediaContainer2* self) {
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Searchable");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.UPnP.MediaContainer2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Searchable"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return FALSE;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void media_container2_proxy_media_container2_interface_init (MediaContainer2Iface* iface) {
	iface->ListChildren = media_container2_proxy_ListChildren;
	iface->ListContainers = media_container2_proxy_ListContainers;
	iface->ListItems = media_container2_proxy_ListItems;
	iface->get_ChildCount = media_container2_dbus_proxy_get_ChildCount;
	iface->get_ItemCount = media_container2_dbus_proxy_get_ItemCount;
	iface->get_ContainerCount = media_container2_dbus_proxy_get_ContainerCount;
	iface->get_Searchable = media_container2_dbus_proxy_get_Searchable;
}


static void _dbus_media_container2_ListChildren (MediaContainer2* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint offset = 0U;
	GVariant* _tmp451_;
	guint max = 0U;
	GVariant* _tmp452_;
	gchar** filter = NULL;
	int filter_length1 = 0;
	GVariant* _tmp453_;
	gchar** _tmp454_;
	int _tmp454__length;
	int _tmp454__size;
	int _tmp454__length1;
	GVariantIter _tmp455_;
	GVariant* _tmp456_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable** result;
	int result_length1 = 0;
	GHashTable** _tmp457_;
	GVariantBuilder _tmp458_;
	int _tmp459_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp451_ = g_variant_iter_next_value (&_arguments_iter);
	offset = g_variant_get_uint32 (_tmp451_);
	g_variant_unref (_tmp451_);
	_tmp452_ = g_variant_iter_next_value (&_arguments_iter);
	max = g_variant_get_uint32 (_tmp452_);
	g_variant_unref (_tmp452_);
	_tmp453_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp454_ = g_new (gchar*, 5);
	_tmp454__length = 0;
	_tmp454__size = 4;
	_tmp454__length1 = 0;
	g_variant_iter_init (&_tmp455_, _tmp453_);
	for (; (_tmp456_ = g_variant_iter_next_value (&_tmp455_)) != NULL; _tmp454__length1++) {
		if (_tmp454__size == _tmp454__length) {
			_tmp454__size = 2 * _tmp454__size;
			_tmp454_ = g_renew (gchar*, _tmp454_, _tmp454__size + 1);
		}
		_tmp454_[_tmp454__length++] = g_variant_dup_string (_tmp456_, NULL);
		g_variant_unref (_tmp456_);
	}
	filter_length1 = _tmp454__length1;
	_tmp454_[_tmp454__length] = NULL;
	filter = _tmp454_;
	g_variant_unref (_tmp453_);
	result = media_container2_ListChildren (self, offset, max, filter, filter_length1, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp457_ = result;
	g_variant_builder_init (&_tmp458_, G_VARIANT_TYPE ("aa{sv}"));
	for (_tmp459_ = 0; _tmp459_ < result_length1; _tmp459_++) {
		GVariantBuilder _tmp460_;
		GHashTableIter _tmp461_;
		gpointer _tmp462_;
		gpointer _tmp463_;
		g_hash_table_iter_init (&_tmp461_, *_tmp457_);
		g_variant_builder_init (&_tmp460_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp461_, &_tmp462_, &_tmp463_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp462_;
			_value = (GVariant*) _tmp463_;
			g_variant_builder_add (&_tmp460_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp458_, g_variant_builder_end (&_tmp460_));
		_tmp457_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp458_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_hash_table_unref), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	filter = (_vala_array_free (filter, filter_length1, (GDestroyNotify) g_free), NULL);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_media_container2_ListContainers (MediaContainer2* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint offset = 0U;
	GVariant* _tmp464_;
	guint max = 0U;
	GVariant* _tmp465_;
	gchar** filter = NULL;
	int filter_length1 = 0;
	GVariant* _tmp466_;
	gchar** _tmp467_;
	int _tmp467__length;
	int _tmp467__size;
	int _tmp467__length1;
	GVariantIter _tmp468_;
	GVariant* _tmp469_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable** result;
	int result_length1 = 0;
	GHashTable** _tmp470_;
	GVariantBuilder _tmp471_;
	int _tmp472_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp464_ = g_variant_iter_next_value (&_arguments_iter);
	offset = g_variant_get_uint32 (_tmp464_);
	g_variant_unref (_tmp464_);
	_tmp465_ = g_variant_iter_next_value (&_arguments_iter);
	max = g_variant_get_uint32 (_tmp465_);
	g_variant_unref (_tmp465_);
	_tmp466_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp467_ = g_new (gchar*, 5);
	_tmp467__length = 0;
	_tmp467__size = 4;
	_tmp467__length1 = 0;
	g_variant_iter_init (&_tmp468_, _tmp466_);
	for (; (_tmp469_ = g_variant_iter_next_value (&_tmp468_)) != NULL; _tmp467__length1++) {
		if (_tmp467__size == _tmp467__length) {
			_tmp467__size = 2 * _tmp467__size;
			_tmp467_ = g_renew (gchar*, _tmp467_, _tmp467__size + 1);
		}
		_tmp467_[_tmp467__length++] = g_variant_dup_string (_tmp469_, NULL);
		g_variant_unref (_tmp469_);
	}
	filter_length1 = _tmp467__length1;
	_tmp467_[_tmp467__length] = NULL;
	filter = _tmp467_;
	g_variant_unref (_tmp466_);
	result = media_container2_ListContainers (self, offset, max, filter, filter_length1, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp470_ = result;
	g_variant_builder_init (&_tmp471_, G_VARIANT_TYPE ("aa{sv}"));
	for (_tmp472_ = 0; _tmp472_ < result_length1; _tmp472_++) {
		GVariantBuilder _tmp473_;
		GHashTableIter _tmp474_;
		gpointer _tmp475_;
		gpointer _tmp476_;
		g_hash_table_iter_init (&_tmp474_, *_tmp470_);
		g_variant_builder_init (&_tmp473_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp474_, &_tmp475_, &_tmp476_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp475_;
			_value = (GVariant*) _tmp476_;
			g_variant_builder_add (&_tmp473_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp471_, g_variant_builder_end (&_tmp473_));
		_tmp470_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp471_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_hash_table_unref), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	filter = (_vala_array_free (filter, filter_length1, (GDestroyNotify) g_free), NULL);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_media_container2_ListItems (MediaContainer2* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint offset = 0U;
	GVariant* _tmp477_;
	guint max = 0U;
	GVariant* _tmp478_;
	gchar** filter = NULL;
	int filter_length1 = 0;
	GVariant* _tmp479_;
	gchar** _tmp480_;
	int _tmp480__length;
	int _tmp480__size;
	int _tmp480__length1;
	GVariantIter _tmp481_;
	GVariant* _tmp482_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable** result;
	int result_length1 = 0;
	GHashTable** _tmp483_;
	GVariantBuilder _tmp484_;
	int _tmp485_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp477_ = g_variant_iter_next_value (&_arguments_iter);
	offset = g_variant_get_uint32 (_tmp477_);
	g_variant_unref (_tmp477_);
	_tmp478_ = g_variant_iter_next_value (&_arguments_iter);
	max = g_variant_get_uint32 (_tmp478_);
	g_variant_unref (_tmp478_);
	_tmp479_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp480_ = g_new (gchar*, 5);
	_tmp480__length = 0;
	_tmp480__size = 4;
	_tmp480__length1 = 0;
	g_variant_iter_init (&_tmp481_, _tmp479_);
	for (; (_tmp482_ = g_variant_iter_next_value (&_tmp481_)) != NULL; _tmp480__length1++) {
		if (_tmp480__size == _tmp480__length) {
			_tmp480__size = 2 * _tmp480__size;
			_tmp480_ = g_renew (gchar*, _tmp480_, _tmp480__size + 1);
		}
		_tmp480_[_tmp480__length++] = g_variant_dup_string (_tmp482_, NULL);
		g_variant_unref (_tmp482_);
	}
	filter_length1 = _tmp480__length1;
	_tmp480_[_tmp480__length] = NULL;
	filter = _tmp480_;
	g_variant_unref (_tmp479_);
	result = media_container2_ListItems (self, offset, max, filter, filter_length1, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp483_ = result;
	g_variant_builder_init (&_tmp484_, G_VARIANT_TYPE ("aa{sv}"));
	for (_tmp485_ = 0; _tmp485_ < result_length1; _tmp485_++) {
		GVariantBuilder _tmp486_;
		GHashTableIter _tmp487_;
		gpointer _tmp488_;
		gpointer _tmp489_;
		g_hash_table_iter_init (&_tmp487_, *_tmp483_);
		g_variant_builder_init (&_tmp486_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp487_, &_tmp488_, &_tmp489_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp488_;
			_value = (GVariant*) _tmp489_;
			g_variant_builder_add (&_tmp486_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp484_, g_variant_builder_end (&_tmp486_));
		_tmp483_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp484_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_hash_table_unref), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	filter = (_vala_array_free (filter, filter_length1, (GDestroyNotify) g_free), NULL);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void media_container2_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "ListChildren") == 0) {
		_dbus_media_container2_ListChildren (object, parameters, invocation);
	} else if (strcmp (method_name, "ListContainers") == 0) {
		_dbus_media_container2_ListContainers (object, parameters, invocation);
	} else if (strcmp (method_name, "ListItems") == 0) {
		_dbus_media_container2_ListItems (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* _dbus_media_container2_get_ChildCount (MediaContainer2* self) {
	guint result;
	GVariant* _reply;
	result = media_container2_get_ChildCount (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}


static GVariant* _dbus_media_container2_get_ItemCount (MediaContainer2* self) {
	guint result;
	GVariant* _reply;
	result = media_container2_get_ItemCount (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}


static GVariant* _dbus_media_container2_get_ContainerCount (MediaContainer2* self) {
	guint result;
	GVariant* _reply;
	result = media_container2_get_ContainerCount (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}


static GVariant* _dbus_media_container2_get_Searchable (MediaContainer2* self) {
	gboolean result;
	GVariant* _reply;
	result = media_container2_get_Searchable (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* media_container2_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "ChildCount") == 0) {
		return _dbus_media_container2_get_ChildCount (object);
	} else if (strcmp (property_name, "ItemCount") == 0) {
		return _dbus_media_container2_get_ItemCount (object);
	} else if (strcmp (property_name, "ContainerCount") == 0) {
		return _dbus_media_container2_get_ContainerCount (object);
	} else if (strcmp (property_name, "Searchable") == 0) {
		return _dbus_media_container2_get_Searchable (object);
	}
	return NULL;
}


static gboolean media_container2_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_media_container2_updated (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.UPnP.MediaContainer2", "Updated", _arguments, NULL);
}


guint media_container2_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_media_container2_dbus_interface_info), &_media_container2_dbus_interface_vtable, data, _media_container2_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "updated", (GCallback) _dbus_media_container2_updated, data);
	return result;
}


static void _media_container2_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_media_container2_updated, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


gchar** media_item2_get_URLs (MediaItem2* self, int* result_length1) {
	g_return_val_if_fail (self != NULL, NULL);
	return MEDIA_ITEM2_GET_INTERFACE (self)->get_URLs (self, result_length1);
}


gchar* media_item2_get_MIMEType (MediaItem2* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return MEDIA_ITEM2_GET_INTERFACE (self)->get_MIMEType (self);
}


static void media_item2_base_init (MediaItem2Iface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType media_item2_get_type (void) {
	static volatile gsize media_item2_type_id__volatile = 0;
	if (g_once_init_enter (&media_item2_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MediaItem2Iface), (GBaseInitFunc) media_item2_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType media_item2_type_id;
		media_item2_type_id = g_type_register_static (G_TYPE_INTERFACE, "MediaItem2", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (media_item2_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (media_item2_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) media_item2_proxy_get_type);
		g_type_set_qdata (media_item2_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.UPnP.MediaItem2");
		g_type_set_qdata (media_item2_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_media_item2_dbus_interface_info));
		g_type_set_qdata (media_item2_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) media_item2_register_object);
		g_once_init_leave (&media_item2_type_id__volatile, media_item2_type_id);
	}
	return media_item2_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (MediaItem2Proxy, media_item2_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_MEDIA_ITEM2, media_item2_proxy_media_item2_interface_init) )
static void media_item2_proxy_class_init (MediaItem2ProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = media_item2_proxy_g_signal;
}


static void media_item2_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
}


static void media_item2_proxy_init (MediaItem2Proxy* self) {
}


static gchar** media_item2_dbus_proxy_get_URLs (MediaItem2* self, int* result_length1) {
	GVariant *_inner_reply;
	gchar** _result;
	int _result_length1;
	gchar** _tmp490_;
	int _tmp490__length;
	int _tmp490__size;
	int _tmp490__length1;
	GVariantIter _tmp491_;
	GVariant* _tmp492_;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "URLs");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.UPnP.MediaItem2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("URLs"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result_length1 = 0;
	_tmp490_ = g_new (gchar*, 5);
	_tmp490__length = 0;
	_tmp490__size = 4;
	_tmp490__length1 = 0;
	g_variant_iter_init (&_tmp491_, _inner_reply);
	for (; (_tmp492_ = g_variant_iter_next_value (&_tmp491_)) != NULL; _tmp490__length1++) {
		if (_tmp490__size == _tmp490__length) {
			_tmp490__size = 2 * _tmp490__size;
			_tmp490_ = g_renew (gchar*, _tmp490_, _tmp490__size + 1);
		}
		_tmp490_[_tmp490__length++] = g_variant_dup_string (_tmp492_, NULL);
		g_variant_unref (_tmp492_);
	}
	_result_length1 = _tmp490__length1;
	_tmp490_[_tmp490__length] = NULL;
	_result = _tmp490_;
	*result_length1 = _result_length1;
	g_variant_unref (_inner_reply);
	return _result;
}


static gchar* media_item2_dbus_proxy_get_MIMEType (MediaItem2* self) {
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "MIMEType");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.UPnP.MediaItem2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("MIMEType"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static void media_item2_proxy_media_item2_interface_init (MediaItem2Iface* iface) {
	iface->get_URLs = media_item2_dbus_proxy_get_URLs;
	iface->get_MIMEType = media_item2_dbus_proxy_get_MIMEType;
}


static void media_item2_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}


static GVariant* _dbus_media_item2_get_URLs (MediaItem2* self) {
	gchar** result;
	int result_length1 = 0;
	gchar** _tmp493_;
	GVariantBuilder _tmp494_;
	int _tmp495_;
	GVariant* _reply;
	result = media_item2_get_URLs (self, &result_length1);
	_tmp493_ = result;
	g_variant_builder_init (&_tmp494_, G_VARIANT_TYPE ("as"));
	for (_tmp495_ = 0; _tmp495_ < result_length1; _tmp495_++) {
		g_variant_builder_add_value (&_tmp494_, g_variant_new_string (*_tmp493_));
		_tmp493_++;
	}
	_reply = g_variant_builder_end (&_tmp494_);
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}


static GVariant* _dbus_media_item2_get_MIMEType (MediaItem2* self) {
	gchar* result;
	GVariant* _reply;
	result = media_item2_get_MIMEType (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* media_item2_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "URLs") == 0) {
		return _dbus_media_item2_get_URLs (object);
	} else if (strcmp (property_name, "MIMEType") == 0) {
		return _dbus_media_item2_get_MIMEType (object);
	}
	return NULL;
}


static gboolean media_item2_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint media_item2_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_media_item2_dbus_interface_info), &_media_item2_dbus_interface_vtable, data, _media_item2_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _media_item2_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



